// BonModManager.h: BonW[}l[WNX
//
/////////////////////////////////////////////////////////////////////////////

#pragma once

#include <Vector>
#include <String>


/////////////////////////////////////////////////////////////////////////////
// IBonModManagerNX
/////////////////////////////////////////////////////////////////////////////

class CBonModManager :	public CBonObject,
						public IBonModManager
{
public:
// CBonObject
	DECLARE_IBONOBJECT(CBonModManager)

// IBonModManager
	virtual const DWORD RegisterModule(void);
	virtual const DWORD GetModuleNum(void) const;
	virtual const DWORD GetModuleName(const DWORD dwIndex, LPTSTR lpszName) const;

// CBonModManager
	CBonModManager(IBonObject * const pOwner);
	virtual ~CBonModManager(void);

protected:
	typedef struct
	{
		HINSTANCE hModule;
		std::wstring strName;
	} MODULEINFO;

	typedef std::vector<MODULEINFO> ModuleList;
	ModuleList m_ModuleList;
};
