// BonBaseIf.h: x[XC^tF[X`
//
/////////////////////////////////////////////////////////////////////////////

#pragma once


/////////////////////////////////////////////////////////////////////////////
// BonIuWFNgC^tF[X
/////////////////////////////////////////////////////////////////////////////

class IBonObject
{
public:
	virtual void Release(void) = 0;
};


/////////////////////////////////////////////////////////////////////////////
// BonW[}l[WC^tF[X
/////////////////////////////////////////////////////////////////////////////

class IBonModManager : public IBonObject
{
public:
	virtual const DWORD RegisterModule(void) = 0;
	virtual const DWORD GetModuleNum(void) const = 0;
	virtual const DWORD GetModuleName(const DWORD dwIndex, LPTSTR lpszName) const = 0;
};


/////////////////////////////////////////////////////////////////////////////
// BonW[J^OC^tF[X
/////////////////////////////////////////////////////////////////////////////

class IBonModCatalog : public IBonObject
{
public:
	virtual const WORD GetVersion(void) const = 0;
	virtual LPCTSTR GetDescription(void) const = 0;
	virtual LPCTSTR GetAuthor(void) const = 0;
	virtual const BONGUID EnumStartupClass(const DWORD dwIndex) const = 0;
};
