// TsDescriptor.cpp: fXNv^NX
//
/////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "BonSDK.h"
#include "TsDescriptor.h"
#include "TsDataEncode.h"


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


/////////////////////////////////////////////////////////////////////////////
// ̎NX͋Lqq̃f[^ێAIDescBlockC^tF[X
// NXێ郁ubNQƂB
// ̂߂̃NX͏IDescBlockC^tF[XʂĎgpȂ
// ȂȂB(PƂŃCX^X𐶐邱Ƃ͂łȂ)
/////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////
// [0x09] Conditional Access Method LqqNX
/////////////////////////////////////////////////////////////////////////////

const WORD CCaMethodDesc::GetCaMethodID(void) const
{
	// MIDԂ
	return (WORD)m_pDescData[0] << 8 | (WORD)m_pDescData[1];
}

const WORD CCaMethodDesc::GetCaPID(void) const
{
	// MPIDԂ
	return (WORD)(m_pDescData[2] & 0x1FU) << 8 | (WORD)m_pDescData[3];
}

const BYTE * CCaMethodDesc::GetPrivateData(void) const
{
	// vCx[gf[^Ԃ
	return &m_pDescData[4];
}

const BYTE CCaMethodDesc::GetPrivateDataSize(void) const
{
	// vCx[gf[^Ԃ
	return m_byDescLen - 4U;
}

CCaMethodDesc::CCaMethodDesc(IBonObject * const pOwner)
	: CDescBase(pOwner)
{
	// Ȃ
}

CCaMethodDesc::~CCaMethodDesc(void)
{
	// Ȃ
}

const bool CCaMethodDesc::ParseData(void)
{
	// TCŶ݃`FbN
	return (m_byDescLen >= 4U)? true : false;
}


/////////////////////////////////////////////////////////////////////////////
// [0x48] Service LqqNX
/////////////////////////////////////////////////////////////////////////////

const BYTE CServiceDesc::GetServiceType(void) const
{
	// T[rX`IDԂ
	return m_pDescData[0];
}

const DWORD CServiceDesc::GetProviderName(LPTSTR lpszDst) const
{
	// ƎҖ`FbN
	const DWORD dwPos = 1UL;
	if(!m_pDescData[dwPos])return 0UL;

	// ƎҖ擾
	TCHAR szName[256] = TEXT("\0");
	CAribString::AribToString(szName, &m_pDescData[dwPos + 1UL], m_pDescData[dwPos]);

	// obt@ɃRs[
	if(lpszDst)::lstrcpy(lpszDst, szName);

	// obt@ɕKvȕԂ
	return ::lstrlen(szName);
}

const DWORD CServiceDesc::GetServiceName(LPTSTR lpszDst) const
{
	// T[rX`FbN
	const DWORD dwPos = (DWORD)m_pDescData[1] + 2UL;
	if(!m_pDescData[dwPos])return 0UL;

	// T[rX擾
	TCHAR szName[256] = TEXT("\0");
	CAribString::AribToString(szName, &m_pDescData[dwPos + 1UL], m_pDescData[dwPos]);

	// obt@ɃRs[
	if(lpszDst)::lstrcpy(lpszDst, szName);

	// obt@ɕKvȕԂ
	return ::lstrlen(szName);
}

CServiceDesc::CServiceDesc(IBonObject * const pOwner)
	: CDescBase(pOwner)
{
	// Ȃ
}

CServiceDesc::~CServiceDesc(void)
{
	// Ȃ
}

const bool CServiceDesc::ParseData(void)
{
	// TCŶ݃`FbN
	return (m_byDescLen >= 3U)? true : false;
}


/////////////////////////////////////////////////////////////////////////////
// [0x4D] Short Event LqqNX
/////////////////////////////////////////////////////////////////////////////

const DWORD CShortEventDesc::GetLanguageCode(void) const
{
	// R[hԂ
	return ((DWORD)m_pDescData[0] << 16) | ((DWORD)m_pDescData[1] << 8) | (DWORD)m_pDescData[2];
}

const DWORD CShortEventDesc::GetEventName(LPTSTR lpszDst) const
{
	// ԑg`FbN
	const DWORD dwPos = 3UL;
	if(!m_pDescData[dwPos])return 0UL;

	// ԑg擾
	TCHAR szName[256] = TEXT("\0");
	CAribString::AribToString(szName, &m_pDescData[dwPos + 1UL], m_pDescData[dwPos]);

	// obt@ɃRs[
	if(lpszDst)::lstrcpy(lpszDst, szName);

	// obt@ɕKvȕԂ
	return ::lstrlen(szName);
}

const DWORD CShortEventDesc::GetEventDesc(LPTSTR lpszDst) const
{
	// ԑgLq`FbN
	const DWORD dwPos = (DWORD)m_pDescData[3] + 4UL;
	if(!m_pDescData[dwPos])return 0UL;

	// ԑgLq擾
	TCHAR szName[256] = TEXT("\0");
	CAribString::AribToString(szName, &m_pDescData[dwPos + 1UL], m_pDescData[dwPos]);

	// obt@ɃRs[
	if(lpszDst)::lstrcpy(lpszDst, szName);

	// obt@ɕKvȕԂ
	return ::lstrlen(szName);
}

CShortEventDesc::CShortEventDesc(IBonObject * const pOwner)
	: CDescBase(pOwner)
{
	// Ȃ
}

CShortEventDesc::~CShortEventDesc(void)
{
	// Ȃ
}

const bool CShortEventDesc::ParseData(void)
{
	// TCŶ݃`FbN
	return (m_byDescLen >= 5U)? true : false;
}


/////////////////////////////////////////////////////////////////////////////
// [0x52] Stream Identifier LqqNX
/////////////////////////////////////////////////////////////////////////////

const BYTE CStreamIdDesc::GetComponentTag(void) const
{
	// R|[lg^OԂ
	return m_pDescData[0];

}

CStreamIdDesc::CStreamIdDesc(IBonObject * const pOwner)
	: CDescBase(pOwner)
{
	// Ȃ
}

CStreamIdDesc::~CStreamIdDesc(void)
{
	// Ȃ
}

const bool CStreamIdDesc::ParseData(void)
{
	// TCŶ݃`FbN
	return (m_byDescLen == 1U)? true : false;
}
