// TsPacket.h: TSpPbgNX
//
/////////////////////////////////////////////////////////////////////////////

#pragma once


/////////////////////////////////////////////////////////////////////////////
// ITsPacketNX
/////////////////////////////////////////////////////////////////////////////

class CTsPacket :	public CMediaData,
					public ITsPacket
{
public:
// CBonObject
	DECLARE_IBONOBJECT(CTsPacket)

// ITsPacket
	virtual const DWORD ParsePacket(BYTE *pContinuityCounter = NULL);
	virtual const WORD GetPID(void) const;
	virtual const bool IsScrambled(void) const;
	virtual const bool HaveAdaptationField(void) const;
	virtual BYTE * GetPayloadData(void) const;
	virtual const BYTE GetPayloadSize(void) const;
	virtual const bool CopyPacket(const ITsPacket *pSrc);

// CMediaData
	virtual const DWORD CopyData(const IMediaData *pSrc);

// CTsPacket
	CTsPacket(IBonObject * const pOwner);
	virtual ~CTsPacket(void);
};
