// BonDlg.cpp : t@C
//

#include "stdafx.h"
#include "Bon.h"
#include "BonDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// AvP[Ṽo[WɎg CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

// 
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CBonDlg _CAO




CBonDlg::CBonDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBonDlg::IDD, pParent)
	, CBonObject(NULL)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

CBonDlg::CBonDlg(IBonObject * const pOwner)
	: CDialog(CBonDlg::IDD, NULL)
	, CBonObject(pOwner)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

CBonDlg::~CBonDlg(void)
{

}

void CBonDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CBonDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_DESTROY()
	ON_WM_TIMER()
END_MESSAGE_MAP()


// CBonDlg bZ[W nh

BOOL CBonDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[VXe j[ɒǉ܂B

	// IDM_ABOUTBOX ́AVXe R}h͈͓̔ɂȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAÕACRݒ肵܂BAvP[ṼC EBhE_CAOłȂꍇA
	//  Framework ́A̐ݒIɍs܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACR̐ݒ
	SetIcon(m_hIcon, FALSE);		// ACR̐ݒ

	// TODO: ɒǉ܂B
	m_pTsSourceTuner	= ::BON_SAFE_CREATE<ITsSourceTuner *>(TEXT("CTsSourceTuner"), dynamic_cast<IMediaDecoderHandler *>(this));
	m_pTsPacketSync		= ::BON_SAFE_CREATE<ITsPacketSync *>(TEXT("CTsPacketSync"), dynamic_cast<IMediaDecoderHandler *>(this));
	m_pTsDescrambler	= ::BON_SAFE_CREATE<ITsDescrambler *>(TEXT("CTsDescrambler"), dynamic_cast<IMediaDecoderHandler *>(this));

	dynamic_cast<IMediaDecoder *>(m_pTsSourceTuner)->SetOutputDecoder(dynamic_cast<IMediaDecoder *>(m_pTsPacketSync));
	dynamic_cast<IMediaDecoder *>(m_pTsPacketSync)->SetOutputDecoder(dynamic_cast<IMediaDecoder *>(m_pTsDescrambler));

	if(m_pTsSourceTuner->OpenTuner(TEXT("CBonWhiteTuner")))::AfxMessageBox(TEXT("`[iI[vs"));
//	if(m_pTsSourceTuner->OpenTuner(TEXT("CBonBlackTuner")))::AfxMessageBox(TEXT("`[iI[vs"));
	if(!m_pTsDescrambler->OpenDescrambler(TEXT("CBcasCardReader")))::AfxMessageBox(TEXT("B-CASJ[hI[vs"));
	
	m_pTsDescrambler->EnableEmmProcess(true);
	
	// nfW
	m_pTsSourceTuner->SetChannel(0UL, 1UL);			// UHF 14ch YTV
	
	// BS
	//m_pTsSourceTuner->SetChannel(0UL, 5UL);		// Star Channel
	//m_pTsSourceTuner->SetChannel(0UL, 2UL);		// WOWOW
	//m_pTsSourceTuner->SetChannel(0UL, 10UL);		// BS-hi
	
	// CS
//	m_pTsSourceTuner->SetChannel(1UL, 2UL);			// ND6 110CS #3
	
	dynamic_cast<IMediaDecoder *>(m_pTsSourceTuner)->PlayDecoder();

	SetTimer(1UL, 1000UL, NULL);

	return TRUE;  // tH[JXRg[ɐݒ肵ꍇATRUE Ԃ܂B
}

void CBonDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAOɍŏ{^ǉꍇAACR`悷邽߂
//  ̃R[hKvłBhLg/r[ fg MFC AvP[V̏ꍇA
//  ́AFramework ɂĎIɐݒ肳܂B

void CBonDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̎lp`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR̕`
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// [U[ŏEBhEhbOĂƂɕ\J[\擾邽߂ɁA
//  VXe̊֐Ăяo܂B
HCURSOR CBonDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CBonDlg::OnDestroy()
{
	CDialog::OnDestroy();

	// TODO: ɃbZ[W nh R[hǉ܂B
	KillTimer(1);
	
	dynamic_cast<IMediaDecoder *>(m_pTsSourceTuner)->StopDecoder();
	m_pTsSourceTuner->CloseTuner();
	m_pTsDescrambler->CloseDescrambler();

	BON_SAFE_RELEASE(m_pTsSourceTuner);
	BON_SAFE_RELEASE(m_pTsPacketSync);
	BON_SAFE_RELEASE(m_pTsDescrambler);
}

void CBonDlg::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: ɃbZ[W nh R[hǉ邩ȀĂяo܂B

//	TRACE(TEXT("ScramblePacketNum = %lu\n"), m_pTsDescrambler->GetScramblePacketNum());



	CDialog::OnTimer(nIDEvent);
}

const DWORD CBonDlg::OnDecoderEvent(IMediaDecoder *pDecoder, const DWORD dwEventID, PVOID pParam)
{
	if(pDecoder == dynamic_cast<IMediaDecoder *>(m_pTsPacketSync)){
		switch(dwEventID){
			case ITsPacketSync::EID_SYNC_ERR :
				TRACE(TEXT("ITsPacketSync::EID_SYNC_ERR\n"));
				break;
			
			case ITsPacketSync::EID_FORMAT_ERR :
				TRACE(TEXT("ITsPacketSync::EID_FORMAT_ERR\n"));
				break;

			case ITsPacketSync::EID_TRANSPORT_ERR :
				TRACE(TEXT("ITsPacketSync::EID_TRANSPORT_ERR\n"));
				break;

			case ITsPacketSync::EID_CONTINUITY_ERR :
				TRACE(TEXT("ITsPacketSync::EID_CONTINUITY_ERR\n"));
				break;
			}
		}
	else if(pDecoder == dynamic_cast<IMediaDecoder *>(m_pTsDescrambler)){
		switch(dwEventID){
			case ITsDescrambler::EID_CANT_DESCRAMBLE :
//				TRACE(TEXT("ITsDescrambler::EID_CANT_DESCRAMBLE\n"));
				break;
			
			case ITsDescrambler::EID_ECM_PROCESSED :
//				TRACE(TEXT("ITsDescrambler::EID_ECM_PROCESSED\n"));
				break;

			case ITsDescrambler::EID_EMM_PROCESSED :
				TRACE(TEXT("ITsDescrambler::EID_EMM_PROCESSED\n"));
				break;
			}
		}

	return 0UL;
}
