// SmartFile.h: ėpt@CXg[WNX
//
/////////////////////////////////////////////////////////////////////////////

#pragma once


/////////////////////////////////////////////////////////////////////////////
// ėpt@CXg[WNX
/////////////////////////////////////////////////////////////////////////////

class CSmartFile :	public CBonObject,
					public ISmartFile
{
public:
// CBonObject
	DECLARE_IBONOBJECT(CSmartFile)

// ISmartFile
	virtual const bool Open(LPCTSTR lpszFileName, const DWORD dwModeFlags = (MF_READ | MF_SHAREREAD), const DWORD dwBuffSize = 0UL);
	virtual void Close(void);

	virtual const DWORD ReadData(BYTE *pBuff, const DWORD dwLen);
	virtual const DWORD ReadData(BYTE *pBuff, const DWORD dwLen, const ULONGLONG llPos);

	virtual const DWORD WriteData(const BYTE *pBuff, const DWORD dwLen);
	virtual const DWORD WriteData(const BYTE *pBuff, const DWORD dwLen, const ULONGLONG llPos);

	virtual const bool SeekPos(const ULONGLONG llPos);
	virtual const ULONGLONG GetPos(void) const;

	virtual const ULONGLONG GetLength(void) const;

// CSmartFile
	CSmartFile(IBonObject * const pOwner);
	virtual ~CSmartFile(void);

protected:
};
