// BonGlobal.h: O[o֐`
//
/////////////////////////////////////////////////////////////////////////////

#pragma once


/////////////////////////////////////////////////////////////////////////////
// O[o֐錾 (IuWFNg\bh)
/////////////////////////////////////////////////////////////////////////////

#ifdef BONSDK_IMPLEMENT
	#define BONAPI	__declspec(dllexport)
#else
	#define BONAPI	__declspec(dllimport)
#endif
#include <typeinfo.h>

// NXt@Ng[\bh^
typedef IBonObject * (* CLASSFACTORYMETHOD)(IBonObject * const pOwner);


// NXt@Ng[API
extern "C"
{
BONAPI const bool BonRegisterFactory(LPCTSTR lpszBCId, CLASSFACTORYMETHOD const pfnFactoryMethod);
BONAPI const bool BonQueryFactory(LPCTSTR lpszBCId);
BONAPI IBonObject * BonCreateInstance(LPCTSTR lpszBCId, IBonObject * const pOwner = NULL);
BONAPI const DWORD BonGetFactoryNum(void);

BONAPI LPCTSTR BonGuidToClassName(const BONGUID BCId);
BONAPI const BONGUID BonClassNameToGuid(LPCTSTR lpszBCId);

// W[}l[WgAPI
BONAPI const IBonModManager * GetModManager(void);
}

// [eBeB[\bh
template <class T> const bool BON_REGISTER_CLASS(void)
{
#ifdef _UNICODE
	WCHAR szClassName[BON_MAX_CLASS_NAME] = TEXT("\0");

	// NXUNICODEɕϊ
	::MultiByteToWideChar(CP_OEMCP, MB_PRECOMPOSED, typeid(T).name(), -1, szClassName, sizeof(szClassName));

	// NXt@Ng[o^
	return ::BonRegisterFactory(&szClassName[6], T::CreateInstance);
#else
	// NXt@Ng[o^
	return ::BonRegisterFactory(typeid(T).name(), T::CreateInstance);
#endif
}

template <class T> T BON_SAFE_CREATE(LPCTSTR lpszBCId, IBonObject * const pOwner = NULL)
{
	// CX^X
	IBonObject * const pNewInstance = ::BonCreateInstance(lpszBCId, pOwner);

	// C^tF[X擾
	T const pDestInterface = dynamic_cast<T>(pNewInstance);

	// ړĨC^tF[XĂȂꍇ̓CX^XJ
	if(pNewInstance && !pDestInterface)pNewInstance->Release();

	return pDestInterface;
}
