// IoObjectIf.h: o̓IuWFNgC^tF[X
//
/////////////////////////////////////////////////////////////////////////////

#pragma once


/////////////////////////////////////////////////////////////////////////////
// Wt@CXg[WC^tF[X
/////////////////////////////////////////////////////////////////////////////

class ISmartFile :				public IBonObject
{
public:
	enum
	{
		MF_READ			= 0x00000001UL,
		MF_WRITE		= 0x00000002UL,
		MF_NEW			= 0x00000004UL,
		MF_SHAREREAD	= 0x00000008UL,
		MF_SHAREWRITE	= 0x00000010UL
	};

	virtual const bool Open(LPCTSTR lpszFileName, const DWORD dwModeFlags = (MF_READ | MF_SHAREREAD), const DWORD dwBuffSize = 0UL) = 0;
	virtual void Close(void) = 0;

	virtual const DWORD ReadData(BYTE *pBuff, const DWORD dwLen) = 0;
	virtual const DWORD ReadData(BYTE *pBuff, const DWORD dwLen, const ULONGLONG llPos) = 0;

	virtual const DWORD WriteData(const BYTE *pBuff, const DWORD dwLen) = 0;
	virtual const DWORD WriteData(const BYTE *pBuff, const DWORD dwLen, const ULONGLONG llPos) = 0;

	virtual const bool SeekPos(const ULONGLONG llPos) = 0;
	virtual const ULONGLONG GetPos(void) const = 0;

	virtual const ULONGLONG GetLength(void) const = 0;
};
