// SyncObject.h: IuWFNgbp[NX
//
/////////////////////////////////////////////////////////////////////////////

#pragma once


/////////////////////////////////////////////////////////////////////////////
// NeBJZNVbp[NX
/////////////////////////////////////////////////////////////////////////////

class CSmartLock
{
public:
	CSmartLock();
	virtual ~CSmartLock();
	
	void Lock(void);
	void Unlock(void);
	
protected:
	CRITICAL_SECTION m_CriticalSection;
};


/////////////////////////////////////////////////////////////////////////////
// ubNXR[vbNNX
/////////////////////////////////////////////////////////////////////////////

class CBlockLock
{
public:
	CBlockLock(CSmartLock *pSmartLock);
	virtual ~CBlockLock();
		
protected:
	CSmartLock *m_pSmartLock;
};


/////////////////////////////////////////////////////////////////////////////
// Cxgbp[NX
/////////////////////////////////////////////////////////////////////////////

class CSmartEvent
{
public:
	enum
	{
		WE_TRIGGER,		// CxgVOiԂɂȂ
		WE_TIMEOUT,		// ^CAEg
		WE_CLOSED		// Cxg͊ɊJĂ
	};

	CSmartEvent(const bool bManualReset = false, const bool bInitialState = false);
	virtual ~CSmartEvent(void);

	const bool SetEvent(void);
	const bool PulseEvent(void);
	const bool ResetEvent(void);

	const DWORD WaitEvent(const DWORD dwTimeout = 0UL);

protected:
	HANDLE m_hEvent;

};


/////////////////////////////////////////////////////////////////////////////
// ~[ebNXbp[NX
/////////////////////////////////////////////////////////////////////////////

class CSmartMutex
{
public:
	CSmartMutex(void);
	virtual ~CSmartMutex(void);

	const bool Create(LPCTSTR lpszName);
	const bool Close(void);

	static const bool IsExist(LPCTSTR lpszName);

protected:
	HANDLE m_hMutex;
};
