// DllMain.cpp: DLLGg[|Cg̒`
//
/////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "BonSDK.h"
#include "BonWhiteTuner.h"
#include "BonBlackTuner.h"


#ifdef _MANAGED
#pragma managed(push, off)
#endif


/////////////////////////////////////////////////////////////////////////////
// t@C[J֐vg^Cv
/////////////////////////////////////////////////////////////////////////////

static void RegisterClassFactory(void);


/////////////////////////////////////////////////////////////////////////////
// DLLGg[
/////////////////////////////////////////////////////////////////////////////

BOOL APIENTRY DllMain(HMODULE hModule, DWORD  ul_reason_for_call, LPVOID lpReserved)
{
	switch(ul_reason_for_call){
		case DLL_PROCESS_ATTACH :

#ifdef _DEBUG
			// [NoL
			::_CrtSetDbgFlag(_CRTDBG_LEAK_CHECK_DF | ::_CrtSetDbgFlag(_CRTDBG_REPORT_FLAG)); 
#endif
			// W[nho^
			CBonWhiteTuner::SetModuleHandle(hModule);
			CBonBlackTuner::SetModuleHandle(hModule);

			// NXt@Ng[o^
			::RegisterClassFactory();

			break;

		case DLL_PROCESS_DETACH :
			
			break;
		}

	return TRUE;
}


static void RegisterClassFactory(void)
{
	// NXt@Ng[o^
	::BON_REGISTER_CLASS<CBonWhiteTuner>();
	::BON_REGISTER_CLASS<CBonBlackTuner>();
}

#ifdef _MANAGED
#pragma managed(pop)
#endif
