// DllMain.cpp: DLLGg[|Cg̒`
//
/////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "BonSDK.h"
#include "TsPacket.h"
#include "PsiSection.h"
#include "TsDescBase.h"
#include "TsPidMapper.h"
#include "TsTable.h"

#include "TsSourceTuner.h"
#include "TsPacketSync.h"
#include "TsDescrambler.h"


#ifdef _MANAGED
#pragma managed(push, off)
#endif


/////////////////////////////////////////////////////////////////////////////
// t@C[J֐vg^Cv
/////////////////////////////////////////////////////////////////////////////

static void RegisterClassFactory(void);


/////////////////////////////////////////////////////////////////////////////
// DLLGg[
/////////////////////////////////////////////////////////////////////////////

BOOL APIENTRY DllMain(HMODULE hModule, DWORD  ul_reason_for_call, LPVOID lpReserved)
{
	switch(ul_reason_for_call){
		case DLL_PROCESS_ATTACH :

#ifdef _DEBUG
			// [NoL
			::_CrtSetDbgFlag(_CRTDBG_LEAK_CHECK_DF | ::_CrtSetDbgFlag(_CRTDBG_REPORT_FLAG)); 
#endif
			// NXt@Ng[o^
			::RegisterClassFactory();

			break;

		case DLL_PROCESS_DETACH :
			
			break;
		}

	return TRUE;
}

static void RegisterClassFactory(void)
{
	// NXt@Ng[o^
	::BON_REGISTER_CLASS<CTsPacket>();
	::BON_REGISTER_CLASS<CPsiSection>();
	::BON_REGISTER_CLASS<CDescBlock>();
	::BON_REGISTER_CLASS<CPsiSectionParser>();
	::BON_REGISTER_CLASS<CTsPidMapper>();
	::BON_REGISTER_CLASS<CPatTable>();
	::BON_REGISTER_CLASS<CCatTable>();
	::BON_REGISTER_CLASS<CPmtTable>();
	::BON_REGISTER_CLASS<CTotTable>();
	
	::BON_REGISTER_CLASS<CTsSourceTuner>();
	::BON_REGISTER_CLASS<CTsPacketSync>();
	::BON_REGISTER_CLASS<CTsDescrambler>();
}

#ifdef _MANAGED
#pragma managed(pop)
#endif
